#ifndef lint
static char rcsid[] =
    "@(#) $Header: xphoon.c,v 1.9 89/03/07 01:17:17 leres Exp $ (LBL)";
#endif

#include <X/Xlib.h>
#include <stdio.h>
#include <math.h>
#include "tws.h"

char *argv0;
int blackflag = 0;
int demoflag = 0;
int printpid = 0;

char *malloc();

main(argc, argv)
	int argc;
	char **argv;
{
	char *display;
	int w, h, cx, cy, r;
	int size;
	short *bits, *xbits;
	int delayminutes = 0;
	int pid;

	argv0 = argv[0];
	getbitmap(&w, &h, &bits, &cx, &cy, &r);

again:
	if (argc > 1 && strcmp(argv[1], "-b") == 0) {
		argv++;
		argc--;
		blackflag = 1;
		goto again;
	}
	if (argc > 1 && strcmp(argv[1], "-d") == 0) {
		argv++;
		argc--;
		demoflag = 1;
		goto again;
	}
	if (argc > 2 && strcmp(argv[1], "-t") == 0) {
		argv++;
		argc--;
		if (sscanf(argv[1], "%d", &delayminutes) != 1)
			goto usage;
		argv++;
		argc--;
		goto again;
	}
	if (argc > 2 && strcmp(argv[1], "-x") == 0) {
		argv++;
		argc--;
		if (sscanf(argv[1], "%d", &cx) != 1)
			goto usage;
		argv++;
		argc--;
		goto again;
	}
	if (argc > 2 && strcmp(argv[1], "-y") == 0) {
		argv++;
		argc--;
		if (sscanf(argv[1], "%d", &cy) != 1)
			goto usage;
		argv++;
		argc--;
		goto again;
	}
	if (argc > 1 && strcmp(argv[1], "-i") == 0) {
		argv++;
		argc--;
		printpid = 1;
		goto again;
	}

	display = 0;
	if (argc > 1) {
		display = argv[1];
		argv++;
		argc--;
	}

	if (argc > 1 || (printpid && delayminutes == 0)) {
usage:
		fprintf(stderr, "usage: %s [-b] [-t minutes [-i]] [display]\n",
		    argv0, XDisplayName(display));
		exit(1);
		
	}

	if (XOpenDisplay(display) == 0) {
		fprintf(stderr, "%s: Can't open display \"%s\"\n",
		    argv0, XDisplayName(display));
		exit(1);
	}

	if (delayminutes <= 0 && ! demoflag) {
		hackbits(dtwstime(), w, h, bits, cx, cy, r);
		setroot(w, h, bits);
		exit(0);
	}

	if (printpid) {
		pid = fork();
		if (pid < 0) {
			perror("fork");
			exit(1);
		} else if (pid > 0) {
			/* Parent just exits */
			exit(0);
		}
		printf("%d\n", getpid());
		fflush(stdout);
	}

	size = BitmapSize(w, h);
	xbits = (short *)malloc(size);
	for (;;) {
		bcopy((char *)bits, (char *)xbits, size);
		hackbits(dtwstime(), w, h, xbits, cx, cy, r);
		setroot(w, h, xbits);
		if ( demoflag )
		    sleep(1);  /* continuous mode */
		else
		    sleep(delayminutes * 60);
	}
	/* NOTREACHED */
}


setroot(w, h, bits)
	int w, h;
	short *bits;
{
	Bitmap bitmap;
	Pixmap pixmap;

	bitmap = XStoreBitmap(w, h, bits);

	if (bitmap == 0) {
		fprintf(stderr, "%s: Unable to store Bitmap", argv0);
		exit(1);
	}
	
	pixmap = XMakePixmap(bitmap, BlackPixel, WhitePixel);
	if (pixmap == 0) {
		fprintf(stderr, "%s: Unable to store Pixmap", argv0);
		exit(1);
	}

	XChangeBackground(RootWindow, pixmap);
	XClear(RootWindow);
	XFreeBitmap(bitmap);
	XFreePixmap(pixmap);
	XFlush();
}


short leftmask[16] = {
    0xffff, 0xfffe, 0xfffc, 0xfff8, 0xfff0, 0xffe0, 0xffc0, 0xff80,
    0xff00, 0xfe00, 0xfc00, 0xf800, 0xf000, 0xe000, 0xc000, 0x8000,
};
short rightmask[16] = {
    0x0000, 0x0001, 0x0003, 0x0007, 0x000f, 0x001f, 0x003f, 0x007f,
    0x00ff, 0x01ff, 0x03ff, 0x07ff, 0x0fff, 0x1fff, 0x3fff, 0x7fff,
};

static short shade_0_bits[] = {
 0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff};
static short shade_1_bits[] = {
 0xfefe,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff};
static short shade_2_bits[] = {
 0xfefe,0xffff,0xfbfb,0xffff,0xffff,0xffff,0xffff,0xffff};
static short shade_3_bits[] = {
 0xfefe,0xffff,0xfbfb,0xffff,0x7f7f,0xffff,0xffff,0xffff};
static short shade_4_bits[] = {
 0xfefe,0xffff,0xfbfb,0xffff,0x7f7f,0xffff,0xffff,0xefef};
static short shade_5_bits[] = {
 0xfefe,0xbfbf,0xfbfb,0xffff,0x7f7f,0xffff,0xffff,0xefef};
static short shade_6_bits[] = {
 0xfefe,0xbfbf,0xfbfb,0xdfdf,0x7f7f,0xffff,0xffff,0xefef};
static short shade_7_bits[] = {
 0xfefe,0xbfbf,0xfbfb,0xdfdf,0x7f7f,0xffff,0xfefe,0xefef};
static short shade_8_bits[] = {
 0xfefe,0xbfbf,0xfbfb,0xdfdf,0x7f7f,0xdfdf,0xfefe,0xefef};
static short shade_9_bits[] = {
 0xfefe,0xbfbf,0xfbfb,0xdfdf,0x7d7d,0xdfdf,0xfefe,0xefef};
static short shade_10_bits[] = {
 0xfefe,0xbfbf,0xfbfb,0xdfdf,0x7d7d,0xdfdf,0xfafa,0xefef};
static short shade_11_bits[] = {
 0xfefe,0xbfbf,0xfbfb,0xdfdf,0x7d7d,0xdfdf,0xfafa,0xafaf};
static short shade_12_bits[] = {
 0xfefe,0xbfbf,0xfafa,0xdfdf,0x7d7d,0xdfdf,0xfafa,0xafaf};
static short shade_13_bits[] = {
 0xfefe,0xafaf,0xfafa,0xdfdf,0x7d7d,0xdfdf,0xfafa,0xafaf};
static short shade_14_bits[] = {
 0xfefe,0xafaf,0xfafa,0xdfdf,0x7575,0xdfdf,0xfafa,0xafaf};
static short shade_15_bits[] = {
 0xfafa,0xafaf,0xfafa,0xdfdf,0x7575,0xdfdf,0xfafa,0xafaf};

short *shades[16] = {
    shade_0_bits,  shade_1_bits,  shade_2_bits,  shade_3_bits,
    shade_4_bits,  shade_5_bits,  shade_6_bits,  shade_7_bits,
    shade_8_bits,  shade_9_bits,  shade_10_bits, shade_11_bits,
    shade_12_bits, shade_13_bits, shade_14_bits, shade_15_bits };

#define PI 3.14159265358979323846  /* Assume not near black hole nor in
				      Tennessee */

double jtime(), phase();

hackbits(t, w, h, bits, cx, cy, r)
	struct tws *t;
	int w, h;
	short *bits;
	int cx, cy, r;
{
	double jd, angphase, cphase, aom, cdist, cangdia, csund, csuang;
	int i;
	register int x, y;
	int xleft, xright;
	double fxleft, fxright;
	double fy;
	int wxright, bxright, wxleft, bxleft;
	int off;
	double cap, ratio;
	int shadeindex;
	short shade;
	static double demoinc = 0.0;

	jd = jtime( t );
	if ( demoflag ) {
		/* Jump ahead a day each time through. */
		jd += demoinc;
		demoinc += 1.0;
	}

	angphase = phase( jd, &cphase, &aom, &cdist, &cangdia, &csund, &csuang);
	cap = cos( angphase );

	/* Hack to figure approximate earthlighting. */
	if ( cphase < 0.1 ) cphase = 0.1;
	if ( cphase > 0.9 ) cphase = 0.9;
	ratio = (1.0 - cphase) / cphase;  /* ratio varies from 9.0 to 0.111 */
	shadeindex = (int) ( ratio / 9.0 * 15.9999 );

#ifdef DEBUG
printf("angphase %f, cap %f\n", angphase, cap);
#endif

	for (i = 0; i < 2 * r; i++) {
		y = cy - r + i;
		if (y >= h || y < 0)
			continue;
		fy = i - r;
		fxright = r * sqrt(1.0 - (fy * fy) / (r * r));
		fxleft = - fxright;
		if (angphase >= 0.0 && angphase < PI)
			fxright *= cap;
		else
			fxleft *= cap;

		xright = fxright + cx;
		if (xright >= w)
			xright = w - 1;
		xleft = fxleft + cx;
		if (xleft < 0)
			xleft = 0;
		if (xleft > xright)
			continue;

		wxright = xright / 16;
		bxright = xright % 16;

		wxleft = xleft / 16;
		bxleft = xleft % 16;

		off = y * ((w + 15) / 16);

		if ( blackflag )
			shade = 0xffff;
		else
			shade = shades[shadeindex][y % 8];
		if (wxleft == wxright)
			bits[wxleft + off] |=
				leftmask[bxleft] & shade & rightmask[bxright];
		else {
			bits[wxleft + off] |= leftmask[bxleft] & shade;
			for (x = wxleft + 1; x < wxright; x++)
				bits[x + off] |= shade;
			bits[wxright + off] |= rightmask[bxright] & shade;
		}
	}
	
}
